# Documentation

## Getting Started
- [FAQ](/flecs/md_docs_FAQ.html)
- [Quickstart](/flecs/md_docs_Quickstart.html)
- [Flecs Script Tutorial](/flecs/md_docs_FlecsScriptTutorial.html)
- [Designing with Flecs](/flecs/md_docs_DesignWithFlecs.html)
- [Getting Started with Unreal Engine](https://github.com/PreyK/Unreal-Minimum-Viable-Flecs)

## Manuals
- [Manual](/flecs/md_docs_Manual.html)
- [Query Manual](/flecs/md_docs_Queries.html)
- [Systems Manual](/flecs/md_docs_Systems.html)
- [Relationships Manual](/flecs/md_docs_Relationships.html)
- [JSON Format Manual](/flecs/md_docs_JsonFormat.html)
- [REST API Manual](/flecs/md_docs_RestApi.html)

## API reference
 - [C API](/flecs/group__c.html)
 - [C++ API](/flecs/group__cpp.html)

## Examples
- [C examples](https://github.com/SanderMertens/flecs/tree/master/examples/c)
- [C++ examples](https://github.com/SanderMertens/flecs/tree/master/examples/cpp)

## Demos
- [Tower Defense (C++)](https://github.com/SanderMertens/tower_defense)
- [City (C)](https://github.com/flecs-hub/city)

## Articles
- [Where are my entities and components](https://ajmmertens.medium.com/building-an-ecs-1-where-are-my-entities-and-components-63d07c7da742)
- [Archetypes and vectorization](https://ajmmertens.medium.com/building-an-ecs-2-archetypes-and-vectorization-fe21690805f9)
- [Making the most of entity identifiers](https://ajmmertens.medium.com/doing-a-lot-with-a-little-ecs-identifiers-25a72bd2647)
- [Building games in ECS with entity relationships](https://ajmmertens.medium.com/building-games-in-ecs-with-entity-relationships-657275ba2c6c)
- [Why storing state machines in ECS is a bad idea](https://ajmmertens.medium.com/why-storing-state-machines-in-ecs-is-a-bad-idea-742de7a18e59)
- [Why vanilla ECS is not enough](https://ajmmertens.medium.com/why-vanilla-ecs-is-not-enough-d7ed4e3bebe5)
- [ECS: From tool to paradigm](https://ajmmertens.medium.com/ecs-from-tool-to-paradigm-350587cdf216)
